Measures
Date: 2019-10-22

org.jmol.shape

## Class Measures

- java.lang.Object
- - org.jmol.shape.Shape
  - - org.jmol.shape.AtomShape
    - - org.jmol.shape.Measures

- All Implemented Interfaces:
    JmolMeasurementClient

      public class Measures
      extends AtomShape
      implements JmolMeasurementClient

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private javajs.util.BS` | `bsSelected`
    `short` | `colix`
    `TickInfo` | `defaultTickInfo`
    `Font` | `font3d`
    `private java.util.Map<java.lang.String,java.lang.Integer>` | `htMin`
    `private java.lang.Boolean` | `intramolecular`
    `private boolean` | `measureAllModels`
    `int` | `measurementCount`
    `javajs.util.Lst<Measurement>` | `measurements`
    `MeasurementPending` | `mPending`
    `private boolean` | `mustBeConnected`
    `private boolean` | `mustNotBeConnected`
    `private RadiusData` | `radiusData`
    `private java.lang.String` | `strFormat`
    `(package private) TickInfo` | `tickInfo`
    `private int` | `tokAction`

    - ### Fields inherited from class org.jmol.shape.AtomShape

      `ac, atoms, bsSizeDefault, colixes, isActive, mad, mads, monomerCount, paletteIDs`

    - ### Fields inherited from class org.jmol.shape.Shape

      `bsColixSet, bsSizeSet, isBioShape, ms, myType, RADIUS_MAX, shapeID, translucentAllowed, translucentLevel, vf, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Measures()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()`
    `private void` | `define(MeasurementData md, int tokAction)`
    `private void` | `defineAll(int iPt, Measurement m, boolean isDelete, boolean isShow, boolean doSelect)`
    `private void` | `defineMeasurement(int i, Measurement m, boolean doSelect)`
    `private void` | `deleteI(int i)`
    `private void` | `deleteM(Measurement m)`
    `private void` | `deleteO(java.lang.Object value)`
    `private void` | `doAction(MeasurementData md, java.lang.String id, int tok)`
    `private int` | `find(Measurement m)`
    `private javajs.util.Lst<java.util.Map<java.lang.String,java.lang.Object>>` | `getAllInfo()`
    `private java.lang.String` | `getAllInfoAsString()`
    `private java.util.Map<java.lang.String,java.lang.Object>` | `getInfo(int index)`
    `java.lang.String` | `getInfoAsString(int index)`
    `private static java.lang.String` | `getMessage(Measurement m, boolean asBitSet)`
    `java.lang.Object` | `getProperty(java.lang.String property, int index)`
    `protected void` | `initModelSet()`
    `void` | `initShape()`
    `void` | `processNextMeasure(Measurement m)`
    `private void` | `reformatDistances()`
    `private void` | `setColor(short colix)`
    `private void` | `setFormats(java.lang.String format)`
    `private void` | `setIndices()`
    `void` | `setProperty(java.lang.String propertyName, java.lang.Object value, javajs.util.BS bsIgnored)`
    `private Measurement` | `setSingleItem(javajs.util.Lst<java.lang.Object> vector)`
    `protected void` | `setSize(int size, javajs.util.BS bsSelected)`
    `void` | `setVisibilityInfo()`
    `private void` | `showHide(boolean isHide)`
    `private void` | `showHideM(Measurement m, boolean isHide)`
    `private void` | `toggle(Measurement m)`
    `private void` | `toggleOn(int[] indices)`

    - ### Methods inherited from class org.jmol.shape.AtomShape

      `checkColixLength, getShapeState, getSize, setAtomClickability, setColixAndPalette, setPropAS, setSize2, setSizeRD, setSizeRD2`

    - ### Methods inherited from class org.jmol.shape.Shape

      `appendCmd, checkBoundsMinMax, checkObjectClicked, checkObjectDragged, checkObjectHovered, coordinateInRange, encodeColor, findNearestAtomIndex, getColix, getColixA, getColixB, getColixI, getColorCommand, getColorCommandUnk, getFontCommand, getIndexFromName, getPropertyData, getPropShape, getShapeDetail, getSizeG, getTranslucentLabel, initializeShape, replaceGroup, setModelSet, setModelVisibilityFlags, setPropS, setShapeSizeRD, wasClicked`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### bsSelected

          private javajs.util.BS bsSelected

    - #### strFormat

          private java.lang.String strFormat

    - #### mustBeConnected

          private boolean mustBeConnected

    - #### mustNotBeConnected

          private boolean mustNotBeConnected

    - #### radiusData

          private RadiusData radiusData

    - #### intramolecular

          private java.lang.Boolean intramolecular

    - #### measureAllModels

          private boolean measureAllModels

    - #### measurementCount

          public int measurementCount

    - #### measurements

          public final javajs.util.Lst<Measurement> measurements

    - #### mPending

          public MeasurementPending mPending

    - #### colix

          public short colix

    - #### tickInfo

          TickInfo tickInfo

    - #### defaultTickInfo

          public TickInfo defaultTickInfo

    - #### font3d

          public Font font3d

    - #### htMin

          private java.util.Map<java.lang.String,java.lang.Integer> htMin

    - #### tokAction

          private int tokAction

  - ### Constructor Detail

    - #### Measures

          public Measures()

  - ### Method Detail

    - #### initModelSet

          protected void initModelSet()

      Overrides:
        `initModelSet` in class `AtomShape`

    - #### initShape

          public void initShape()

      Overrides:
        `initShape` in class `AtomShape`

    - #### setSize

          protected void setSize(int size,
                                 javajs.util.BS bsSelected)

      Overrides:
        `setSize` in class `AtomShape`

    - #### setProperty

          public void setProperty(java.lang.String propertyName,
                                  java.lang.Object value,
                                  javajs.util.BS bsIgnored)

      Specified by:
        `setProperty` in class `Shape`

    - #### setSingleItem

          private Measurement setSingleItem(javajs.util.Lst<java.lang.Object> vector)

    - #### getProperty

          public java.lang.Object getProperty(java.lang.String property,
                                              int index)

      Overrides:
        `getProperty` in class `Shape`
      Returns:
        true if serviced

    - #### clear

          public void clear()

    - #### setColor

          private void setColor(short colix)

    - #### setFormats

          private void setFormats(java.lang.String format)

    - #### showHide

          private void showHide(boolean isHide)

    - #### showHideM

          private void showHideM(Measurement m,
                                 boolean isHide)

    - #### toggle

          private void toggle(Measurement m)

    - #### toggleOn

          private void toggleOn(int[] indices)

    - #### deleteM

          private void deleteM(Measurement m)

    - #### deleteO

          private void deleteO(java.lang.Object value)

    - #### defineAll

          private void defineAll(int iPt,
                                 Measurement m,
                                 boolean isDelete,
                                 boolean isShow,
                                 boolean doSelect)

    - #### find

          private int find(Measurement m)

    - #### setIndices

          private void setIndices()

    - #### define

          private void define(MeasurementData md,
                              int tokAction)

    - #### processNextMeasure

          public void processNextMeasure(Measurement m)

      Specified by:
        `processNextMeasure` in interface `JmolMeasurementClient`

    - #### defineMeasurement

          private void defineMeasurement(int i,
                                         Measurement m,
                                         boolean doSelect)

    - #### getMessage

          private static java.lang.String getMessage(Measurement m,
                                                     boolean asBitSet)

    - #### deleteI

          private void deleteI(int i)

    - #### doAction

          private void doAction(MeasurementData md,
                                java.lang.String id,
                                int tok)

    - #### reformatDistances

          private void reformatDistances()

    - #### getAllInfo

          private javajs.util.Lst<java.util.Map<java.lang.String,java.lang.Object>> getAllInfo()

    - #### getAllInfoAsString

          private java.lang.String getAllInfoAsString()

    - #### getInfo

          private java.util.Map<java.lang.String,java.lang.Object> getInfo(int index)

    - #### getInfoAsString

          public java.lang.String getInfoAsString(int index)

      Overrides:
        `getInfoAsString` in class `AtomShape`
      Returns:
        script, but only for Measures

    - #### setVisibilityInfo

          public void setVisibilityInfo()